import argparse

parser = argparse.ArgumentParser("cifar")
parser.add_argument('--data', type=str, default='/home/work/dataset/cifar/', help='location of the data corpus')
parser.add_argument('--batch_size', type=int, default=128, help='batch size')
parser.add_argument('--learning_rate', type=float, default=0.05, help='init learning rate')
parser.add_argument('--learning_rate_min', type=float, default=0.001, help='min learning rate')
parser.add_argument('--momentum', type=float, default=0.9, help='momentum')
parser.add_argument('--weight_decay', type=float, default=3e-4, help='weight decay')
parser.add_argument('--report_freq', type=float, default=50, help='report frequency')
parser.add_argument('--gpu', type=int, default=0, help='gpu device id')
parser.add_argument('--epochs', type=int, default=50, help='num of training epochs')
parser.add_argument('--init_channels', type=int, default=16, help='num of init channels')
parser.add_argument('--n_classes', type=int, default=10, help='num of classes')
parser.add_argument('--layers', type=int, default=8, help='total number of layers')
parser.add_argument('--model_path', type=str, default='saved_models', help='path to save the model')
parser.add_argument('--cutout', action='store_true', default=False, help='use cutout')
parser.add_argument('--cutout_length', type=int, default=16, help='cutout length')
parser.add_argument('--drop_path_prob', type=float, default=0.0, help='drop path probability')
parser.add_argument('--save', type=str, default='EXP', help='experiment name')
parser.add_argument('--exp_name', type=str, default='normal-noisy', help='experiment name')
parser.add_argument('--seed', type=int, default=2, help='random seed')
parser.add_argument('--grad_clip', type=float, default=5, help='gradient clipping')
parser.add_argument('--train_portion', type=float, default=0.5, help='portion of training data')
parser.add_argument('--unrolled', action='store_true', default=False, help='use one-step unrolled validation loss')
parser.add_argument('--arch_learning_rate', type=float, default=3e-4, help='learning rate for arch encoding')
parser.add_argument('--arch_weight_decay', type=float, default=1e-3, help='weight decay for arch encoding')
parser.add_argument('--noise_mean', type=float, default=0.0, help='noise mean, shared by skip and pooling')
parser.add_argument('--noise_type', type=str, default='gaussian', choices=['gaussian', 'uniform'], help='noise type')
parser.add_argument('--noise_mixture', type=str, default='additive', choices=['additive', 'multiplicative'], help='noise mixture type')
parser.add_argument('--noise_decay', action='store_true', default=False, help='add noise decay or not')
parser.add_argument('--add_noise_skip', action='store_true', default=False, help='add noise to skip')
parser.add_argument('--exclude_skip', action='store_true', default=False, help='exclude skip when NFA')
parser.add_argument('--noise_for_all', action='store_true', default=False, help='add noise for all ops (NFA)')
parser.add_argument('--factor_skip', type=float, default=0.2, help='noise factor of std to skip')
parser.add_argument('--compute_hessian', action='store_true', default=False, help='compute or not Hessian')
parser.add_argument('--report_freq_hessian', type=int, default=50, help='report frequency hessian')
parser.add_argument('--pretrained_weights', type=str, default=None, help='path to weights')
parser.add_argument('--frozen-epochs', default=0, type=int, help='frozen epochs before alpha update')
# for drawing landscape and ev calculation
parser.add_argument('--debug', action='store_true', default=False, help='use one-step unrolled validation loss')
parser.add_argument('--disable_cuda', action='store_true', default=False, help='disable cuda')
parser.add_argument('--ev_start_epoch', type=int, default=50, help='starting id of checkpoint to load for ev calculation')
parser.add_argument('--x', type=str, default='-1:1:51', help='A string with format xmin:x_max:xnum')
parser.add_argument('--y', type=str, default='-1:1:51', help='A string with format ymin:y_max:ynum')
parser.add_argument('--space', type=str, default='s0', help='select space')
parser.add_argument('--task_id', type=int, default=0, help='select task')
parser.add_argument('--checkpoint_epoch', type=int, default=50, help='select checkpoint')
parser.add_argument('--test_infer', action='store_true', default=False, help='run inference to test whether the model is loaded correctly')
parser.add_argument('--show', action='store_true', default=False, help='show graph before saving')
parser.add_argument('--azim', type=float, default=-60, help='azimuthal angle for 3d landscape')
parser.add_argument('--elev', type=float, default=30, help='elevation angle for 3d landscape')
args = parser.parse_args()
